<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from xml/schema/CRM/Core/LocBlock.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:d8b81ad2d5429a693c6681a08b36d2ab)
 */

/**
 * Database access object for the LocBlock entity.
 */
class CRM_Core_DAO_LocBlock extends CRM_Core_DAO {
  const EXT = 'civicrm';
  const TABLE_ADDED = '2.0';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_loc_block';

  /**
   * Icon associated with this entity.
   *
   * @var string
   */
  public static $_icon = 'fa-map-o';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique ID
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $address_id;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $email_id;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $phone_id;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $im_id;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $address_2_id;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $email_2_id;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $phone_2_id;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $im_2_id;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_loc_block';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? ts('Locations') : ts('Location');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Location Block ID'),
          'description' => ts('Unique ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'html' => [
            'type' => 'Number',
          ],
          'readonly' => TRUE,
          'add' => '2.0',
        ],
        'address_id' => [
          'name' => 'address_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Address ID'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.address_id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'FKClassName' => 'CRM_Core_DAO_Address',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Address"),
          ],
          'add' => '2.0',
        ],
        'email_id' => [
          'name' => 'email_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Email ID'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.email_id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'FKClassName' => 'CRM_Core_DAO_Email',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Email"),
          ],
          'add' => '2.0',
        ],
        'phone_id' => [
          'name' => 'phone_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Phone ID'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.phone_id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'FKClassName' => 'CRM_Core_DAO_Phone',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Phone"),
          ],
          'add' => '2.0',
        ],
        'im_id' => [
          'name' => 'im_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('IM ID'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.im_id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'FKClassName' => 'CRM_Core_DAO_IM',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Instant Messenger"),
          ],
          'add' => '2.0',
        ],
        'address_2_id' => [
          'name' => 'address_2_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Address 2 ID'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.address_2_id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'FKClassName' => 'CRM_Core_DAO_Address',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Address 2"),
          ],
          'add' => '2.0',
        ],
        'email_2_id' => [
          'name' => 'email_2_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Email 2 ID'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.email_2_id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'FKClassName' => 'CRM_Core_DAO_Email',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Email 2"),
          ],
          'add' => '2.0',
        ],
        'phone_2_id' => [
          'name' => 'phone_2_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('Phone 2 ID'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.phone_2_id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'FKClassName' => 'CRM_Core_DAO_Phone',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Phone 2"),
          ],
          'add' => '2.0',
        ],
        'im_2_id' => [
          'name' => 'im_2_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => ts('IM 2 ID'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_loc_block.im_2_id',
          'table_name' => 'civicrm_loc_block',
          'entity' => 'LocBlock',
          'bao' => 'CRM_Core_DAO_LocBlock',
          'localizable' => 0,
          'FKClassName' => 'CRM_Core_DAO_IM',
          'FKColumnName' => 'id',
          'html' => [
            'label' => ts("Instant Messenger 2"),
          ],
          'add' => '2.0',
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'loc_block', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'loc_block', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
