<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from standaloneusers/xml/schema/CRM/Standaloneusers/UserRole.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:261a62783e6628b718b812b096080e69)
 */
use CRM_Standaloneusers_ExtensionUtil as E;

/**
 * Database access object for the UserRole entity.
 */
class CRM_Standaloneusers_DAO_UserRole extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_user_role';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique UserRole ID
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * FK to User
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $user_id;

  /**
   * FK to Role
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $role_id;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_user_role';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('User Roles') : E::ts('User Role');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('ID'),
          'description' => E::ts('Unique UserRole ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_user_role.id',
          'table_name' => 'civicrm_user_role',
          'entity' => 'UserRole',
          'bao' => 'CRM_Standaloneusers_DAO_UserRole',
          'localizable' => 0,
          'html' => [
            'type' => 'Number',
          ],
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'user_id' => [
          'name' => 'user_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('User ID'),
          'description' => E::ts('FK to User'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_user_role.user_id',
          'table_name' => 'civicrm_user_role',
          'entity' => 'UserRole',
          'bao' => 'CRM_Standaloneusers_DAO_UserRole',
          'localizable' => 0,
          'FKClassName' => 'CRM_Standaloneusers_DAO_User',
          'html' => [
            'type' => 'EntityRef',
            'label' => E::ts("User"),
          ],
          'add' => NULL,
        ],
        'role_id' => [
          'name' => 'role_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Role ID'),
          'description' => E::ts('FK to Role'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_user_role.role_id',
          'table_name' => 'civicrm_user_role',
          'entity' => 'UserRole',
          'bao' => 'CRM_Standaloneusers_DAO_UserRole',
          'localizable' => 0,
          'FKClassName' => 'CRM_Standaloneusers_DAO_Role',
          'html' => [
            'type' => 'EntityRef',
            'label' => E::ts("Role"),
          ],
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'user_role', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'user_role', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
